﻿using Infragistics.Win.UltraWinSchedule;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        
        public Form1()
        {
            InitializeComponent();
          
            string mdb = @"E:\igwork\Sample\2018\197017\WindowsFormsApp1\WindowsFormsApp1\WinScheduleData.mdb";
            
            ultraCalendarInfo1.AppointmentDataError += UltraCalendarInfo1_AppointmentDataError;

            ultraCalendarInfo1.DataBindingsForAppointments.DataSource =
                LoadFromFile(mdb);
            this.ultraCalendarInfo1.DataBindingsForAppointments.SubjectMember = "Subject";
            
            this.ultraCalendarInfo1.DataBindingsForAppointments.StartDateTimeMember = "StartDateTime";
            this.ultraCalendarInfo1.DataBindingsForAppointments.EndDateTimeMember = "EndDateTime";
          
            //Comment this line out will result in appointments showing up in the DayView. 
            this.ultraCalendarInfo1.DataBindingsForAppointments.AllPropertiesMember = "AllProperties";
          
        }

        private void UltraCalendarInfo1_AppointmentDataError(object sender, AppointmentDataErrorEventArgs e)
        {
           
        }

        public static DataSet LoadFromFile(string fileName)
        {
            DataSet result = new DataSet();

            // For convenience, the DataSet is identified by the name of the loaded file (without extension).
            result.DataSetName = Path.GetFileNameWithoutExtension(fileName).Replace(" ", "_");

            // Compute the ConnectionString (using the OLEDB v12.0 driver compatible with ACCDB and MDB files)
            fileName = Path.GetFullPath(fileName);
            string connString = string.Format("Provider=Microsoft.ACE.OLEDB.12.0;Data Source={0};User Id=Admin;Password=", fileName);

            // Opening the Access connection
            using (OleDbConnection conn = new OleDbConnection(connString))
            {
                conn.Open();

                // Getting all user tables present in the Access file (Msys* tables are system thus useless for us)
                DataTable dt = conn.GetSchema("Tables");
                List<string> tablesName = dt.AsEnumerable().Select(dr => dr.Field<string>("TABLE_NAME")).Where(dr => !dr.StartsWith("MSys")).ToList();

                // Getting the data for every user tables
                foreach (string tableName in tablesName)
                {
                    using (OleDbCommand cmd = new OleDbCommand(string.Format("SELECT * FROM [{0}]", tableName), conn))
                    {
                        using (OleDbDataAdapter adapter = new OleDbDataAdapter(cmd))
                        {
                            // Saving all tables in our result DataSet.
                            DataTable buf = new DataTable("[" + tableName + "]");
                            adapter.Fill(buf);
                            result.Tables.Add(buf);
                        } // adapter
                    } // cmd
                } // tableName
            } // conn

            // Return the filled DataSet
            return result;
        }
    }
}
